/*

ARIA header files for use with ARNL 1.7.1

Copyright(C) 2004, 2005 ActivMedia Robotics, LLC. 
Copyright(C) 2006, 2007, 2008, 2009 MobileRobots Inc.
All rights reserved.

This copy of Aria was relicensed for use with Arnl and the Arnl
license by MobileRobots Inc.  If you wish to download a seperate
distribution of Aria licensed under the GPL or a commercial license go to
http://www.mobilerobots.com/SOFTWARE/aria.html or contact MobileRobots
Inc, at robots@mobilerobots.com or MobileRobots Inc,
10 Columbia Drive, Amherst, NH 03031; 800-639-9481

MobileRobots Inc hereby grants to other individuals or
organizations permission to use this software with Arnl and in
compliance with the Arnl license.  This software may not be
distributed to others except by MobileRobots Inc.

MobileRobots Inc does not make any representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.

*/
#ifndef ARNETPACKETSENDERTCP_H
#define ARNETPACKETSENDERTCP_H

#include "Aria.h"
#include "ArNetPacket.h"

class ArNetPacketSenderTcp
{
public:
  /// Constructor
  AREXPORT ArNetPacketSenderTcp();
  /// Destructor
  AREXPORT ~ArNetPacketSenderTcp();
  
  /// Sets the socket this sender uses
  AREXPORT void setSocket(ArSocket *socket);
  /// Gets the socket this sender uses
  AREXPORT ArSocket *getSocket(void);

  /// Sets the connection timeout
  AREXPORT void setBackupTimeout(double connectionTimeoutInMins);

  /// Sets debug logging
  AREXPORT void setDebugLogging(bool debugLogging);

  /// Sets the logging prefix
  AREXPORT void setLoggingPrefix(const char *prefix);

  /// Sends a packet
  AREXPORT void sendPacket(ArNetPacket *packet, 
			   const char *loggingString = "");

  /// Tries to send the data there is to be sent
  AREXPORT bool sendData(void);
protected:
  ArMutex myDataMutex;
  bool myDebugLogging;
  std::string myLoggingPrefix;
  ArLog::LogLevel myVerboseLogLevel;
  ArSocket *mySocket;
  std::list<ArNetPacket *> myPacketList;
  ArNetPacket *myPacket;
  int myAlreadySent;
  const char *myBuf;
  int myLength;
  double myBackupTimeout;
  ArTime myLastGoodSend;

};

#endif 
